<template>
  <div class="ob-filter" :class="{'--close': !isOpen}">
    <transition name="slideInDown">
      <template v-if="isOpen">
        <div class="ob-filter__panel">
          <div class="row">
            <div class="col-xs-3">
              <ob-select
                  label="Откуда"
                  placeholder="Выберите"
                  :remote-opt="api.contract.getLocations"
                  :value="filters.fromLocationUuid"
                  :is-auto-complete="true"
                  display-exp="russian_name"
                  data-qa="spot_client-locationFrom"
                  @input="onChangeFromLocation"
              />
            </div>
            <div class="col-xs-3">
              <ob-select
                  label="Куда"
                  placeholder="Выберите"
                  :remote-opt="api.contract.getLocations"
                  :value="filters.toLocationUuid"
                  :is-auto-complete="true"
                  display-exp="russian_name"
                  data-qa="spot_client-locationTo"
                  @input="onChangeToLocation"
              />
            </div>
            <div class="col-xs-2">
              <ob-date-picker
                  label="Погрузка от"
                  ref="from-date"
                  :value="filters.fromDate"
                  data-qa="spot_client-fromDate"
                  @input="onChangeFromDate"
              />
            </div>
            <div class="col-xs-4 ob-filter__refresh">
              <div class="ob-filter__refresh-button">
                <mini-loader v-show="isLoader" />
                <span
                  data-qa="spot_client-refreshButton"
                  @click="updateFilters"
                >Обновить</span>
              </div>
            </div>
          </div>
          <div class="row">
            <div class="col-xs-3">
              <ob-select
                  label="Вид автотранспорта"
                  placeholder="Выберите"
                  :value="filters.resourceSpeciesUuid"
                  value-exp="uuid"
                  display-exp="title"
                  property="uuid"
                  :is-standart="true"
                  :remote-opt="getVehicleItems"
                  data-qa="spot_client-resourceSpecies"
                  @input="onChangeResourceSpecies"
              />
            </div>
            <div class="col-xs-3">
              <ob-select
                  :items="transportTypes"
                  :value="filters.resourceTypeUuid"
                  :disabled="!transportTypes.length"
                  label="Тип автотранспорта"
                  placeholder="Выберите"
                  value-exp="uuid"
                  display-exp="title"
                  property="uuid"
                  data-qa="spot_client-typeOfTransports"
                  @input="onChangeTransportTypes"
              />
            </div>
            <div class="col-xs-3">
              <ob-select
                  label="Тип аукциона"
                  placeholder="Выберите"
                  :items="auctionTypes"
                  :value="filters.auctionType"
                  value-exp="value"
                  display-exp="titleShort"
                  data-qa="spot_client-auctionType"
                  @input="onChangeAuctionType"
              />
            </div>
            <div class="col-xs-3 clear-filter">
              <span
                data-qa="spot_client-clearButton"
                @click="clearFilters"
              >
                <span>Очистить</span>
                <i class="icon close"></i>
              </span>
            </div>
          </div>
        </div>
      </template>
    </transition>
    <div class="ob-filter__close" @click="showPanel">
      <i :class="['icon ', isOpen ? 'chevron-up' : 'chevron-down']" />
    </div>
  </div>
</template>

<script>
import api from '@/api'
import { AUCTION_TYPES } from '@/resources/enum'
import MiniLoader from '@/components/MiniLoader'
import ObSelect from 'common-components/src/obComponents/obSelect/index'
import ObDatePicker from 'common-components/src/obComponents/obDatePickerConstructor/index'
import moment from 'moment';

export default {
  name: 'obFiltersFromToDateType',
  components: {
    MiniLoader,
    ObSelect,
    ObDatePicker
  },
  props: {
    isLoader: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      api,
      searchAddress: '',
      transport: '',
      transportTypes: [],
      auctionTypes: Object.values(AUCTION_TYPES),
      isOpen: true,
      filters: {
        fromLocationUuid: null,
        toLocationUuid: null,
        fromDate: null,
        resourceSpeciesUuid: null,
        resourceTypeUuid: null,
        auctionType: null
      },
      route: ''
    }
  },
  mounted() {
    this.filters = {
      fromLocationUuid: this.$route.query.from ? this.getSelectedFromLocation(this.$route.query.from) : null,
      toLocationUuid: this.$route.query.to ? this.getSelectedToLocation(this.$route.query.to) : null,
      fromDate: this.$route.query.d ? new Date(this.$route.query.d) : null,
      resourceSpeciesUuid: this.$route.query.a,
      resourceTypeUuid: this.$route.query.v ? this.getResourceType(this.$route.query.a, this.$route.query.v) : null,
      auctionType: this.$route.query.t
    }
  },
  methods: {
    async getVehicleItems () {
      return await api.dictionaries.resources
                      .getResourceSpeciesByClass('e7519b46-faf4-11e9-8f0b-362b9e155667')
    },
    async getTransportTypes (id) {
      try {
        let resourceTypes = await api.resources
                                     .getResourceTypesDropdownBySpecies(id)
        this.transportTypes = resourceTypes
      } catch (e) {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки данных"
        });
      }
    },
    showPanel () {
      this.isOpen = !this.isOpen;
      this.$emit('changeHeight')
    },
    updateFilters () {
      this.$router.push(
        { query: {
          auctionState: this.$route.query.auctionState ? this.$route.query.auctionState : 'ALL',
          from: this.filters.fromLocationUuid,
          to: this.filters.toLocationUuid,
          d: this.filters.fromDate ? moment(this.filters.fromDate).format('YYYY-MM-DD') : null,
          a: this.filters.resourceSpeciesUuid,
          v: this.filters.resourceTypeUuid,
          t: this.filters.auctionType
        }
      });
      this.$emit('update', this.filters)
    },
    clearFilters () {
      this.transportTypes = [];
      this.$refs['from-date'].localValue = '';
      this.filters = {};
      this.$router.replace({query: {
          auctionState: this.$route.query.auctionState
        }
      });
      this.updateFilters();
    },
    updateFiltersData (data) {
      this.filters = {
        ...this.filters,
        ...data
      }
    },
    getSelectedFromLocation (uuid) {
      this.onChangeFromLocation(uuid);
      return uuid
    },
    getSelectedToLocation (uuid) {
      this.onChangeToLocation(uuid);
      return uuid
    },
    getResourceType (view_uuid, type_uuid) {
      this.onChangeResourceSpecies(view_uuid);
      this.onChangeTransportTypes(type_uuid);
      return type_uuid
    },
    onChangeFromLocation (value) {
      this.fromLocationUuid = value
      this.updateFiltersData({ fromLocationUuid: this.fromLocationUuid })
    },
    onChangeToLocation (value) {
      this.toLocationUuid = value
      this.updateFiltersData({ toLocationUuid: this.toLocationUuid })
    },
    onChangeFromDate (value) {
      this.fromDate = value
      this.updateFiltersData({ fromDate: this.fromDate })
    },
    onChangeResourceSpecies (value) {
      this.resourceSpeciesUuid = value
      this.getTransportTypes(value)
      this.updateFiltersData({ resourceSpeciesUuid: this.resourceSpeciesUuid })
    },
    onChangeTransportTypes (value) {
      this.resourceTypeUuid = value
      this.updateFiltersData({ resourceTypeUuid: this.resourceTypeUuid })
    },
    onChangeAuctionType (value) {
      this.auctionType = value
      this.updateFiltersData({ auctionType: this.auctionType })
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";

.ob-filter {
  position: relative;
  padding: 16px;

  &.--close {
    min-height: 50px;
  }

  &__panel {
    .row {
      margin: 10px 0 20px;
    }

    .clear-filter {
      display: flex;
      align-items: flex-end;
      justify-content: flex-end;
      color: $color-grey-span;
      font-size: 12px;

      span {
        cursor: pointer;

        &:hover {
          opacity: .8;
        }
      }

      .icon {
        line-height: 14px;
        font-size: 9px;
        margin-left: 8px;
      }
    }
  }

  &__refresh {
    display: flex;
    height: 52px;
    align-items: flex-start;
    justify-content: flex-end;
    line-height: 20px;
    letter-spacing: 0.4px;
    color: $color-blue-navy-blue;

    &-button {
      cursor: pointer;
      display: inherit;
      padding-top: 3px;

      span {
        margin: 0 35px 0 10px;
      }

      &:hover {
        color: rgba($color-blue-navy-blue, 0.8);
      }
    }
  }

  &__close {
    position: absolute;
    top: 28px;
    right: 24px;
    cursor: pointer;
    color: $color-blue-navy-blue;
    font-size: 20px;
    z-index: 1;

    &:hover {
      opacity: .8;
    }
  }
}
</style>
